routes/web.php
<?php


DB::listen(function ($query){
    //echo "<pre>{{$query->time}}</pre>";
    //echo "<pre>{{$query->sql}}</pre>";
});
/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return view('welcome');
    //return ['uno'=>'1','dos'=>'2'];
});

Route::get('saludo/{nombre?}', 'PrincipalController@saludo')->name('saludo')->middleware('verified');

Route::get('admin/lista', 'PrincipalController@lista')->name('lista');

Route::get('condicional', 'PrincipalController@condicional')->name('condicional');






/*########################## MENSAJES ###########################*/
/*Route::get('mensaje', 'MensajesController@index')->name('mensaje.index');
Route::get('mensaje/create', 'MensajesController@create')->name('mensaje.create');
Route::post('mensaje/store','MensajesController@store')->name('mensaje.store');
Route::get('mensaje/{id}','MensajesController@show')->name('mensaje.show');
Route::get('mensaje/{id}/edit','MensajesController@edit')->name('mensaje.edit');
Route::put('mensaje/{id}','MensajesController@update')->name('mensaje.update');
Route::delete('mensaje/{id}','MensajesController@destroy')->name('mensaje.destroy');*/

Route::resource('mensaje','MensajesController');


Route::resource('usuario','UsuariosController')->except('show');







/*Route::get('login', 'Auth\LoginController@showLoginForm')->name('login');
Route::post('login', 'Auth\LoginController@login');
Route::post('logout', 'Auth\LoginController@logout')->name('logout');*/




Auth::routes(['verify' => true]);

Route::get('/home', 'HomeController@index')->name('home');

app/Http/Controllers/UsuariosController.php
<?php

namespace App\Http\Controllers;

use App\Http\Requests\UserRequest;
use App\Models\Mensaje;
use App\Models\Role;
use App\User;
use Cache;
use Illuminate\Http\Request;
use Illuminate\Support\Str;

class UsuariosController extends Controller
{


    public function __construct()
    {
        $this->middleware('auth');
        $this->middleware('role:admin')->except('edit', 'update');
    }

    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $key = request()->query('page',1);
        $usuarios = Cache::tags('usuarios')->rememberForever('usuarios'.$key, function () {
            return User::with('roles', 'nota')->paginate(10);
        });
        return view('usuarios.index', compact('usuarios'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $roles = Role::query()->select('id', 'display_name')->get();
        return view('usuarios.create', compact('roles'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $usuario = new User($request->all());
        $usuario->password = bcrypt('password');
        $usuario->save();
        $usuario->roles()->attach($request->role);
        Cache::tags('usuarios')->flush();
        return redirect()->route('usuario.index')->with('success','El usuario fue creado');
    }


    /**
     * Show the form for editing the specified resource.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $usuario = Cache::tags('usuarios')->rememberForever('usuarios.show'.$id, function () use ($id) {
            return $usuario = User::query()->findOrFail($id);
        });
        $this->authorize('view', $usuario);

        return view('usuarios.edit', [
            'usuario' => $usuario,
            'roles' => Role::query()->select('id', 'display_name')->get()
        ]);
    }

    /**
     * Update the specified resource in storage.
     *
     * @param \Illuminate\Http\Request $request
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function update(UserRequest $request, $id)
    {
        $usuario = User::query()->findOrFail($id);
        $this->authorize('view', $usuario);
        $usuario->update($request->all());
        if(auth()->user()->hasRole(['admin'])){
            $usuario->roles()->sync($request->role);
        }
        Cache::tags('usuarios')->flush();
        return redirect()->back()->with('success', 'El usuario sido actualizado');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param int $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $usuario = User::query()->findOrFail($id);
        $usuario->delete();
        $usuario->roles()->detach();
        Cache::tags('usuarios')->flush();
        return redirect()->route('usuario.index')->with('success', 'El usuario sido eliminado');
    }
}

resources/views/usuarios/create.blade.php
@extends('layouts.app')


@section('content')

    @if(session()->has('success'))
        <div class="alert alert-success" role="alert">
            {{session()->get('success')}}
        </div>
    @endif

    <div class="row justify-content-center mt-3">
        <div class="col-md-8 col-12">
            <form action="{{route('usuario.store')}}" method="post">
                @csrf
                @include('usuarios.form_usuario', ['usuario' => new \App\User()])
            </form>
        </div>

    </div>

@stop

resources/views/usuarios/edit.blade.php
@extends('layouts.app')


@section('content')

    @if(session()->has('success'))
        <div class="alert alert-success" role="alert">
            {{session()->get('success')}}
        </div>
    @endif

    <div class="row justify-content-center mt-3">
        <div class="col-md-8 col-12">
            <form action="{{route('usuario.update', $usuario->id)}}" method="post">
                @csrf
                @method('PUT')
                @include('usuarios.form_usuario')
            </form>
        </div>

    </div>

@stop

resources/views/usuarios/form_usuario.blade.php
<div class="card">
    <div class="card-header">
        <h3 class="card-title">Información usuario</h3>
    </div>
    <div class="card-body">
        <div class="form-group">
            <label for="nombre">Name:</label>
            <input type="text" name="name" id="name" class="form-control"
                   value="{{old('name', $usuario->name)}}">
            {{$errors->first('nombre')}}
        </div>
        <div class="form-group">
            <label for="email">email:</label>
            <input type="text" name="email" id="email" class="form-control"
                   value="{{old('email', $usuario->email)}}">
            {{$errors->first('email')}}
        </div>
        @if(auth()->user()->hasRole(['admin']))
            <div class="form-group">
                <label for="email" class="d-block">Roles:</label>
                @foreach($roles as $role)
                    <div class="form-check form-check-inline">
                        <input class="form-check-input" type="checkbox"
                               {{$usuario->roles->contains($role)?'checked':''}}  name="role[]"
                               value="{{$role->id}}">
                        <label class="form-check-label">{{$role->display_name}}</label>
                    </div>
                @endforeach
            </div>
        @endif
    </div>
    <div class="card-footer">
        <button class="btn btn-primary">Enviar</button>
    </div>
</div>

resources/views/usuarios/index.blade.php
@extends('layouts.app')


@section('content')

    @if(session()->has('success'))
        <div class="alert alert-success" role="alert">
            {{session()->get('success')}}
        </div>
    @endif

    <div class="row justify-content-center mt-3">
        <div class="col-12">

            <div class="card">
                <div class="card-header d-flex justify-content-between">
                    <h3 class="card-title">Lista de usuarios</h3>
                    <a href="{{route('usuario.create')}}" class="btn btn-primary">Nuevo usuario</a>
                </div>
                <div class="card-body">
                    <table class="table table-striped table-hover">
                        <thead class="bg-dark text-white">
                        <tr>
                            <th>Id</th>
                            <th>Nombre</th>
                            <th>Email</th>
                            <th>Rol</th>
                            <th>Nota</th>
                            <th>Acciones</th>
                        </tr>
                        </thead>
                        <tbody>
                        @foreach($usuarios as $usario)
                            <tr>
                                <td>{{$usario->id}}</td>
                                <td>{{$usario->name}}</td>
                                <td>{{$usario->email}}</td>
                                <td>{{$usario->roles->pluck('display_name')->implode(' - ')}}</td>
                                <td>{{$usario->nota?$usario->nota->body:''}}</td>
                                <td>
                                    <a
                                            class="btn btn-info btn-sm text-white"
                                            href="{{route('usuario.edit',$usario->id)}}"
                                            data-toggle="tooltip" data-placement="top"
                                            title="Editar">
                                        <li class="fa fa-edit"></li>
                                    </a>
                                    <form style="display: inline-block" method="post"
                                          action="{{route('usuario.destroy', $usario->id)}}">
                                        @csrf
                                        @method('delete')
                                        <button type="submit" onclick="return confirm('Esta seguro que desea eliminar')"
                                                class="btn btn-danger btn-sm" data-toggle="tooltip" data-placement="top"
                                                title="Eliminar">
                                            <li class="fa fa-trash"></li>
                                        </button>
                                    </form>
                                </td>
                            </tr>
                        @endforeach
                        </tbody>
                    </table>
                    {{$usuarios->links()}}
                </div>
            </div>
        </div>

    </div>

@stop

@section('scripts')
    <script>
        $(function () {
            $('[data-toggle="tooltip"]').tooltip()
        })
    </script>
@endsection